unit hiRemoteAccessManager;

interface
     
uses Messages,Windows,Kol,Share,Debug,Win;

type
  TWinEx = class;
  PWinEx = TWinEx;
  TWinEx = class(THIWin)
end;

type
  THIRemoteAccessManager = class(TDebug)
   private
     fControlManager: IControlManager;
     WE: PWinEx;
     OldMessage: TOnMessage;     
     sControl: PControl;
     Icon: PIcon;

     fOnMouseEnter: THI_Event;
     fOnMouseLeave: THI_Event;
     fOnPaint: THI_Event;
     fOnErase: THI_Event;
     fOnSplitUp: THI_Event;

     procedure SetControlManager(Value: IControlManager);
     function OnMessage(var Msg: TMsg; var Rslt: Integer): Boolean;
   public
	 _event_onKeyUp: THI_Event;
	 _event_onKeyDown: THI_Event;
	 _event_onChar: THI_Event;	 
	 _event_onShow: THI_Event;
	 _event_onHide: THI_Event;
	 _event_onResize: THI_Event;	 
	 _event_onMouseDown: THI_Event;
	 _event_onMouseMove: THI_Event;
	 _event_onMouseWheel: THI_Event;
	 _event_onMouseUp: THI_Event;	 
	 _event_onMove: THI_Event;
	 _event_onDblClick: THI_Event;
	 _event_onSetFocus: THI_Event;
	 _event_onKillFocus: THI_Event;

	 destructor Destroy; override;
     procedure _work_doLeft(var _Data: TData; Index: word);
     procedure _work_doTop(var _Data: TData; Index: word);
     procedure _work_doWidth(var _Data: TData; Index: word);
     procedure _work_doHeight(var _Data: TData; Index: word);
     procedure _work_doColor(var _Data: TData; Index: word);
     procedure _work_doVisible(var _Data: TData; Index: word);
     procedure _work_doEnabled(var _Data: TData; Index: word);
     procedure _work_doHint(var _Data: TData; Index: word);
     procedure _work_doSetFocus(var _Data: TData; Index: word);
     procedure _work_doSendToBack(var _Data: TData; Index: word);
     procedure _work_doBringToFront(var _Data: TData; Index: word);
     procedure _work_doCenterPos(var _Data: TData; Index: word);
     procedure _work_doAlphaBlendValue(var _Data: TData; Index: word);
     procedure _work_doCaption(var _Data: TData; Index: word); 
     procedure _work_doRedraw(var _Data: TData; Index: word); 
     procedure _var_Handle(var _Data: TData; Index: word);
     procedure _var_PHandle(var _Data: TData; Index: word);     
     procedure _var_Width(var _Data: TData; Index: word);
     procedure _var_Height(var _Data: TData; Index: word);
     procedure _var_Left(var _Data: TData; Index: word);
     procedure _var_Top(var _Data: TData; Index: word);
     procedure _var_MouseX(var _Data: TData; Index: word);
     procedure _var_MouseY(var _Data: TData; Index: word);
     procedure _var_Color(var _Data: TData; Index: word);
     procedure _var_Caption(var _Data: TData; Index: word);     
     procedure _var_Icon(var _Data: TData; Index: word);
     procedure _var_SizeHeader(var _Data: TData; Index: word);
     procedure _var_SizeBorder(var _Data: TData; Index: word);      

     property _prop_ControlManager: IControlManager read fControlManager write SetControlManager;
     property _event_onSplitUp: THI_Event write fOnSplitUp;
     property _event_onMouseEnter: THI_Event read fOnMouseEnter write fOnMouseEnter;
     property _event_onMouseLeave: THI_Event read fOnMouseLeave write fOnMouseLeave;
     property _event_onPaint: THI_Event read fOnPaint write fOnPaint;
     property _event_onEraseBkgnd: THI_Event read fOnErase write fOnErase;
  end;

implementation

function THIRemoteAccessManager.OnMessage;
begin
  Result := false;
  Case Msg.message of
    US_KEYUP:
      _hi_onEvent(_event_onKeyUp, Msg.lparam);
    US_KEYDOWN:
      _hi_onEvent(_event_onKeyDown, Msg.lparam);
    US_CHAR:
      _hi_onEvent(_event_onChar, string(Msg.lparam));
    US_SHOW:
      _hi_onEvent(_event_onShow);
    US_HIDE:
      _hi_onEvent(_event_onHide);
    US_RESIZE:
      _hi_onEvent(_event_onResize);
    US_MOUSEDOWN:
      _hi_onEvent(_event_onMouseDown, Msg.lparam);
    US_MOUSEMOVE:
      _hi_onEvent(_event_onMouseMove, Msg.lparam);
    US_MOUSEUP:
      _hi_onEvent(_event_onMouseUp, Msg.lparam);
    US_MOUSEWHEEL:
	  _hi_onEvent(_event_onMouseWheel, Msg.lparam);
    US_MOVE:
      _hi_onEvent(_event_onMove);
    US_PAINT:
      _hi_onEvent(fOnPaint, Msg.lparam);  
    US_ERASEBKGND:
      _hi_onEvent(fOnErase, Msg.lparam); 
    US_MOUSEDBLCLK:
      _hi_onEvent(_event_onDblClick, Msg.lparam);
    US_MOUSEENTER:
      _hi_onEvent(fOnMouseEnter);  
    US_MOUSELEAVE:
      _hi_onEvent(fOnMouseLeave);
    US_SETFOCUS:
      _hi_onEvent(_event_onSetFocus);
    US_KILLFOCUS:
      _hi_onEvent(_event_onKillFocus);
    US_SPLITUP:
      _hi_onEvent(fOnSplitUp);
  end;	  
  Result := Result or _hi_OnMessage(OldMessage, Msg, Rslt);  
end;  

destructor THIRemoteAccessManager.Destroy;
begin
  If Assigned(Icon) then Icon.free;
  if Assigned(fControlManager) then
  WE.Control.OnMessage := OldMessage;
  inherited;
end;

procedure THIRemoteAccessManager.SetControlManager;
begin
  fControlManager := Value;
  if not Assigned(fControlManager) then exit;
  sControl := fControlManager.ctrlpoint;

  WE := PWinEx(fControlManager.getclass);

  OldMessage:= sControl.OnMessage;
  sControl.OnMessage := OnMessage;
  
  if Assigned(fOnMouseEnter.Event) then
    WE.SetMouseEnter(WE.fOnMouseEnter);

  if Assigned(fOnMouseLeave.Event) then
    WE.SetMouseLeave(WE.fOnMouseLeave);

  if Assigned(fOnPaint.Event) then
    WE.SetOnPaint(WE.fOnPaint);

  if Assigned(fOnErase.Event) then
    WE.SetOnErase(WE.fOnErase);

  if Assigned(fOnSplitUp.Event) then
    WE.SetOnSplitUp(WE.fOnSplitUp);
                                                
end;

procedure THIRemoteAccessManager._work_doLeft;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Left := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doTop;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Top := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doWidth;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Width := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doHeight;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Height := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doColor;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Color := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doVisible;
begin
  if not Assigned(fControlManager) then exit;
  WE._work_doVisible(_Data, Index);  
end;

procedure THIRemoteAccessManager._work_doEnabled;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Enabled := ReadBool(_Data);
end;

procedure THIRemoteAccessManager._work_doHint;
begin
  if not Assigned(fControlManager) then exit;
  WE._work_doHint(_Data, Index);
end;

procedure THIRemoteAccessManager._work_doSetFocus;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Focused := true;
end;

procedure THIRemoteAccessManager._work_doSendToBack;
begin
  if not Assigned(fControlManager) then exit;
  sControl.SendToBack;
end;

procedure THIRemoteAccessManager._work_doBringToFront;
begin
  if not Assigned(fControlManager) then exit;
  sControl.BringToFront;  
end;

procedure THIRemoteAccessManager._work_doCenterPos;
begin
  if not Assigned(fControlManager) then exit;
  WE._work_doCenterPos(_Data, Index);  
end;

procedure THIRemoteAccessManager._work_doAlphaBlendValue;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
    sControl.AlphaBlend := ToInteger(_Data);
end;

procedure THIRemoteAccessManager._work_doCaption;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Caption := ToString(_Data); 
end;

procedure THIRemoteAccessManager._work_doRedraw;
begin
  if not Assigned(fControlManager) then exit;
  sControl.Invalidate; 
end;

procedure THIRemoteAccessManager._var_Handle;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Handle);  
end;

procedure THIRemoteAccessManager._var_PHandle;     
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, integer(sControl));
end;

procedure THIRemoteAccessManager._var_Width;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Width);
end;

procedure THIRemoteAccessManager._var_Height;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Height);
end;

procedure THIRemoteAccessManager._var_Left;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Left);
end;

procedure THIRemoteAccessManager._var_Top;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, sControl.Top);
end;

procedure THIRemoteAccessManager._var_MouseX;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, WE.Ms.X);
end;

procedure THIRemoteAccessManager._var_MouseY;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, WE.Ms.Y);
end;

procedure THIRemoteAccessManager._var_Color;
begin
  if not Assigned(fControlManager) then exit;
  dtInteger(_Data, Color2RGB(sControl.Color));
end;

procedure THIRemoteAccessManager._var_Caption;
begin
  if not Assigned(fControlManager) then exit;
  dtString(_Data, sControl.Caption);
end; 

procedure THIRemoteAccessManager._var_Icon;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
  begin
    if Assigned(Icon) then
      Icon.Clear
    else
      Icon := NewIcon;
    Icon.Handle := sControl.Icon;
    dtIcon(_Data, Icon);
  end
  else
    dtNull(_Data);    
end;

procedure THIRemoteAccessManager._var_SizeHeader;
var
  Pt: TPoint;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
  begin
    Pt.x := 0; Pt.y := 0;
    ClientToScreen(sControl.Handle, Pt);
    dtInteger(_Data, Pt.Y - sControl.Top);
  end
  else
    dtNull(_Data);    
end;

procedure THIRemoteAccessManager._var_SizeBorder;  
var
  Pt: TPoint;
begin
  if not Assigned(fControlManager) then exit;
  if sControl.IsForm then
  begin
    Pt.x := 0; Pt.y := 0;
    ClientToScreen(sControl.Handle, Pt);
    dtInteger(_Data, Pt.X - sControl.Left);
  end
  else
    dtNull(_Data); 
end;
end.